#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>

#define	PI		3.141592
#define	OPT		1	/*@OPT = 1@wIcesij	*/
					/*@OPT = 0@ʏ̂cesi[j	*/

void fft1core(float a_rl[], float a_im[], int length, 
	int ex, float sin_tbl[], float cos_tbl[], float buf[]);
void cstb(int length, int inv, float sin_tbl[], float cos_tbl[]);
void birv(float a[], int length, int ex, float b[]);

/*--- fft1 --- Pees̎s ---------------------------------------------
	a_rl:	f[^io͌pj
	a_im:	f[^io͌pj
	ex:		f[^Qׂ̂ŗ^(f[^ = 2exj
	inv:	1: cesC-1: tces
-----------------------------------------------------------------------------*/
int fft1(float a_rl[], float a_im[], int ex, int inv)
{
	int		i, length = 1;
	float  	*sin_tbl;	/* SINvZpe[u@*/
	float  	*cos_tbl;	/* COSvZpe[u@*/
	float	*buf;		/* Ɨpobt@@*/

	for (i = 0; i < ex; i++) length *= 2;		/* f[^̌vZ */
	sin_tbl = (float *)malloc((size_t)length*sizeof(float));
	cos_tbl = (float *)malloc((size_t)length*sizeof(float));
	buf = (float *)malloc((size_t)length*sizeof(float));
	if ((sin_tbl == NULL) || (cos_tbl == NULL) || (buf == NULL)) {
		return -1;
	}
	cstb(length, inv, sin_tbl, cos_tbl);	/* SIN,COSe[u쐬 */
	fft1core(a_rl, a_im, length, ex, sin_tbl, cos_tbl, buf);
	free(sin_tbl);
	free(cos_tbl);
	return 0;
}

/*--- fft1core --- PeešvZ̊jɂȂ镔 ---------------------------
	a_rl:	f[^io͌pj
	a_im:	f[^io͌pj
	ex:		f[^Qׂ̂ŗ^(f[^ = 2exj
	sin_tbl:	SINvZpe[u
	cos_tbl:	COSvZpe[u
-----------------------------------------------------------------------------*/
void fft1core(float a_rl[], float a_im[], int length, 
	int ex, float sin_tbl[], float cos_tbl[], float buf[])
{
	int		i, j, k, w, j1, j2;
	int		numb, lenb, timb;
	float   xr, xi, yr, yi, nrml;

	if (OPT == 1) {
		for (i = 1; i < length; i+=2) {
			a_rl[i] = -a_rl[i];
			a_im[i] = -a_im[i];
		}
	}
	numb = 1;
	lenb = length;
	for (i = 0; i < ex; i++) {
		lenb /= 2;
		timb = 0;
		for (j = 0; j < numb; j++) {
			w = 0;
			for (k = 0; k < lenb; k++) {
				j1 = timb + k;
				j2 = j1 + lenb;
				xr = a_rl[j1];
				xi = a_im[j1];
				yr = a_rl[j2];
				yi = a_im[j2];
				a_rl[j1] = xr + yr;
				a_im[j1] = xi + yi;
				xr = xr - yr;
				xi = xi - yi;
				a_rl[j2] = xr*cos_tbl[w] - xi*sin_tbl[w];
				a_im[j2] = xr*sin_tbl[w] + xi*cos_tbl[w];
				w += numb;
			}
			timb += (2*lenb);
		}
		numb *= 2;
	}
	birv(a_rl, length, ex, buf);		/*@f[^̕׊@*/
	birv(a_im, length, ex, buf);		/*@f[^̕׊@*/
	if (OPT == 1) {
		for (i = 1; i < length; i+=2) {
			a_rl[i] = -a_rl[i];
			a_im[i] = -a_im[i];
		}
	}
	nrml = (float)(1.0 / sqrt((float)length));
	for (i = 0; i < length; i++) {
		a_rl[i] *= nrml;
		a_im[i] *= nrml;
	}
}

/*--- cstb --- SIN,COSe[u쐬 --------------------------------------------
	length:		f[^
	inv:		1: ces, -1: tces
	sin_tbl:	SINvZpe[u
	cos_tbl:	COSvZpe[u
-----------------------------------------------------------------------------*/
void cstb(int length, int inv, float sin_tbl[], float cos_tbl[])
{
	int		i;
	float  	xx, arg;

	xx = (float)(((-PI) * 2.0) / (float)length);
	if (inv < 0) xx = -xx;
	for (i = 0; i < length; i++) {
		arg = (float)i * xx;
		sin_tbl[i] = (float)sin(arg);
		cos_tbl[i] = (float)cos(arg);
	}
}

/*--- birv --- f[^̕׊ -----------------------------------------------
	a:		f[^̔z
	length:	f[^
	ex:		f[^Qׂ̂ŗ^(length = 2exj
	b:		Ɨpobt@
-----------------------------------------------------------------------------*/
void birv(float a[], int length, int ex, float b[])
{
	int	i, ii, k, bit;

	for (i = 0; i < length; i++) {
		for (k = 0, ii=i, bit=0; ; bit<<=1, ii>>=1) {
			bit = (ii & 1) | bit;
			if (++k == ex) break;
		}
		b[i] = a[bit];
	}
	for (i = 0; i < length; i++) 
		a[i] = b[i];
}
