#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"Params.h"

void fft1core(float a_rl[], float a_im[], int length, 
	int ex, float sin_tbl[], float cos_tbl[], float buf[]);
void cstb(int length, int inv, float sin_tbl[], float cos_tbl[]);
void rvmtx1(float a[Y_SIZE][X_SIZE], float b[X_SIZE][Y_SIZE], 
	int xsize, int ysize);
void rvmtx2(float a[X_SIZE][Y_SIZE], float b[Y_SIZE][X_SIZE], 
	int xsize, int ysize);

/*--- fft2 --- Qees̎s ---------------------------------------------
		iX_SIZECY_SIZEQׂ̂̏ꍇɌj
	a_rl:	f[^io͌pj
	a_im:	f[^io͌pj
	inv:	1: cesC-1: tces
-----------------------------------------------------------------------------*/
int fft2 (float a_rl[Y_SIZE][X_SIZE], float a_im[Y_SIZE][X_SIZE], int inv)
{
	float	*b_rl;		/* f[^]uƗpzij*/
	float	*b_im;		/* f[^]uƗpzij*/
	float	*hsin_tbl;	/* pSINvZpe[u		*/
	float	*hcos_tbl;	/* pCOSvZpe[u		*/
	float	*vsin_tbl;	/* pSINvZpe[u		*/
	float	*vcos_tbl;	/* pCOSvZpe[u		*/
	float	*buf_x;		/* Ɨpobt@ij	*/
	float	*buf_y;		/* Ɨpobt@ij	*/
	int		i;

	b_rl = (float *)calloc((size_t)X_SIZE*Y_SIZE, sizeof(float));
	b_im = (float *)calloc((size_t)X_SIZE*Y_SIZE, sizeof(float));
	hsin_tbl = (float *)calloc((size_t)X_SIZE, sizeof(float));
	hcos_tbl = (float *)calloc((size_t)X_SIZE, sizeof(float));
	vsin_tbl = (float *)calloc((size_t)Y_SIZE, sizeof(float));
	vcos_tbl = (float *)calloc((size_t)Y_SIZE, sizeof(float));
	buf_x = (float *)malloc((size_t)X_SIZE*sizeof(float));
	buf_y = (float *)malloc((size_t)Y_SIZE*sizeof(float));
	if ((b_rl == NULL) || (b_im == NULL)
		|| (hsin_tbl == NULL) || (hcos_tbl == NULL)
		|| (vsin_tbl == NULL) || (vcos_tbl == NULL)
		|| (buf_x == NULL) || (buf_y == NULL)) {
		return -1;
	}
	cstb(X_SIZE, inv, hsin_tbl, hcos_tbl);	/* pSIN,COSe[u쐬	*/
	cstb(Y_SIZE, inv, vsin_tbl, vcos_tbl);	/* pSIN,COSe[u쐬	*/
	/* ̂ees */
	for (i = 0; i < Y_SIZE; i++) {
		fft1core(&a_rl[(long)i][0], &a_im[(long)i][0],
					X_SIZE, X_EXP, hsin_tbl, hcos_tbl, buf_x);
	}
	/* Qf[^̓]u */
	rvmtx1((float (*)[X_SIZE])a_rl, (float (*)[X_SIZE])b_rl, X_SIZE, Y_SIZE);
	rvmtx1((float (*)[X_SIZE])a_im, (float (*)[X_SIZE])b_im, X_SIZE, Y_SIZE);
	/* ̂ees */
	for (i = 0; i < X_SIZE; i++) {
		fft1core(&b_rl[(long)Y_SIZE*i], &b_im[(long)Y_SIZE*i], 
					Y_SIZE, Y_EXP, vsin_tbl, vcos_tbl, buf_y);
	}
	/* Qf[^̓]u */
	rvmtx2((float (*)[Y_SIZE])b_rl, (float (*)[Y_SIZE])a_rl, X_SIZE, Y_SIZE);
	rvmtx2((float (*)[Y_SIZE])b_im, (float (*)[Y_SIZE])a_im, X_SIZE, Y_SIZE);
	free(b_rl);
	free(b_im);
	free(hsin_tbl);
	free(hcos_tbl);
	free(vsin_tbl);
	free(vcos_tbl);
	return 0;
}

/*--- rvmtx1 --- Qf[^̓]u -------------------------------------------
	a:		Q̓f[^
	b:		Qo̓f[^
	xsize:	f[^
	ysize:	f[^
-----------------------------------------------------------------------------*/
void rvmtx1(float a[Y_SIZE][X_SIZE], float b[X_SIZE][Y_SIZE], 
	int xsize, int ysize)
{
	int  i, j;

	for (i = 0; i < ysize; i++) {
		for (j = 0; j < xsize; j++)
			b[j][i] = a[i][j];
	}
}

/*--- rvmtx2 --- Qf[^̓]u -------------------------------------------
	a:		Q̓f[^
	b:		Qo̓f[^
	xsize:	f[^
	ysize:	f[^
-----------------------------------------------------------------------------*/
void rvmtx2(float a[X_SIZE][Y_SIZE], float b[Y_SIZE][X_SIZE], 
	int xsize, int ysize)
{
	int i, j;

	for (i = 0; i < ysize; i++) {
		for (j = 0; j < xsize; j++)
			b[i][j] = a[j][i];
	}
}
